## 	**HYCO扫码配对使用文档**

​																				 [HYCO技术团队]()

[TOC]

#### **前言**

> 每一个文档的出现，意味着前行的路有一盏明灯指引着我们。《HYCO扫码配对使用文档》能够帮助你更好的了解并开发程序对接我司的穿戴式设备。
>
> HYCO专注于穿戴式产品的研发、生产、销售和服务，并提供整体应用解决方案。[Ring Scanner]()（指环式扫描器）系列产品均具有小身材、大能量、大智慧的特点。
>
> - 小身材--体积小巧、轻便；
>
> - l 大能量--可持续工作时间24小时（每3秒扫描一次），充满电后连续扫描次数30000+次 ，稳定可靠；
>
> - l 大智慧--可连接蓝牙4.0手机、平板电脑、工控设备等，更可以根据用户的实际操作定制出光方式，带给用户最大的方便快捷。
>
>   HYCO第三方开发文档》是HYCO集体智慧结晶和经验总结，为DHL、顺风、百事、沃尔玛、圆通、京东等客户长期开发迭代和优化经验系统地整理成册，便于第三方开发者更加高效、高质量地对接HYCO SDK，呈现给用户体验好、性能优、稳定性佳、安全性高的产品。
>
>   官方网址:[http://www.hycoiot.com](http://www.hycoiot.com)
>
>   微信公众号：hyco-4006308608
>
>   咨询热线：4006-308-608 丨15000096211
>
>   微信：浩创指环王
>
>   官方微博:浩创-节省人力
>
>   地址:上海市青浦区华徐公路999号E通世界北区A座3楼302

#### **增加定位和蓝牙权限**

```java
<uses-permission android:name="android.permission.BLUETOOTH"/>
<uses-permission android:name="android.permission.BLUETOOTH_ADMIN"/>
<uses-permission android:name="android.permission.ACCESS_COARSE_LOCATION"/>
<uses-permission android:name="android.permission.ACCESS_FINE_LOCATION"/>
```

[^注意]: 由于Android系统原因，6.0之后定位权限需要动态申请，请务必在您的项目中申请

#### **注册组件**

```java
<activity android:name="com.hyco.sdk.ui.SingleBleActivity"/>
<activity android:name="com.hyco.sdk.ui.ListBLeActivity" />
<service android:name="com.hyco.sdk.server.HycoService"/>
```

#### **傻瓜式连接**

[^单设备连接]: 在页面直接跳转SingleBleActivity，如下：

```java
startActivity(new Intent(MainActivity.this, SingleBleActivity.class));
```

[^多设备连接]: 在页面直接跳转ListBLeActivity，如下：

```java
startActivity(new Intent(MainActivity.this, ListBLeActivity.class));
```

#### **自定义集成**

1.    `Activity继承 PermissionActivity`

   [^]: PermissionActivity 中我们已经为您封装了一系列方法以及权限获取等，您也可以自己根绝实际情况使用或不使用

   ```java
   public class SingleBleActivity extends PermissionActivity {
       .....
   }
   ```

2. `初始化 BleBIZ 对象`

   [^]: 该类为我们SDK的核心类

   ```java
   bleBIZ = new BleBIZ(this, locale);
   ```

3. `绑定服务`

   [^]: requestPermissionSuccess 方法是我们为您封装好的，该方法将在判断您的权限已经赋予APP后执行，所以建议您在这里绑定服务，当然您也可以根据自己的实际情况使用。

   ```java
   public void requestPermissionSuccess() {
           super.requestPermissionSuccess();
           this.bleBIZ.bindService(this.ble, true);
       }
   ```

4. `解绑服务`

   [^]: 如果参数传true，则在解绑后停止服务，指环也就断开了。一般我们设置false即可。

   ```java
     protected void onDestroy() {
           super.onDestroy();
           this.bleBIZ.unbindService(false);
       }
   ```

5. `搜索设备`

   ```java
   bleBIZ.onStartSearchBle("修改为你需要连接的指环6位pin码")
   ```

6. `停止搜索`

   ```java
   bleBIZ.onStopSearchBle()
   ```

7. `连接设备`

   ```java
   bleBIZ.onConnectBle("修改为您获取到的设备mac地址", BleMethod.MAC);
   ```

8. `断开设备`

   ```java
   bleBIZ.onDisConnectBle("修改为您获取到的设备mac地址", BleMethod.MAC);
   ```

9. `设置回调方法`

   ```java
    protected void onResume() {
           super.onResume();
           bleBIZ.setHycoBle(this.ble);
       }
       private HycoBle ble = new HycoBle() {
           public void bleConnectCallback(boolean flag, BleDevice device) {
               super.bleConnectCallback(flag, device);
               SingleBleActivity.this.updateView(device, flag);
           }
   
           public void onConnectBLe(List<BleDevice> devices) {
               super.onConnectBLe(devices);
               //连接的设备
           }
   
           @Override
           public void disConnectFinish(BleDevice device) {
               super.disConnectFinish(device);
               //断开
           }
   
           public void bindServiceFinish() {
               //可以在绑定完成后进行连接模式的设置，单链接或多连接
               SingleBleActivity.this.bleBIZ.setModel(HycoModel.HYCO_SINGLE_MODEL);
           }
   
           public void onScanData(String barcode) {
               super.onScanData(barcode);
               //回调获取的扫码信息
           }
           public void onStartDiscovery() {
               super.onStartDiscovery();
               //开始搜索
           }
   
           public void theEndSearch() {
               super.theEndSearch();
               //搜索结束
           }
           public void enable(BluetoothAdapter adapter) {
               super.enable(adapter);
               //蓝牙打开
               if (!adapter.isEnabled()) {
                   adapter.enable();
               }
           }
           public void connecting() {
               super.connecting();
               //正在连接
           }
           @Override
           public void updatePower(BleDevice device) {
               super.updatePower(device);
               //电量
           }
       };
   
   
   ```

10.`振动`

```Java
 bleBIZ.vibration();
```

11.`获取设备序列号`

```Java
//获取机型+序列号
bleBIZ.getSerialNoWithDeviceType(new OnGetSerialListener() {
            @Override
            public void onGetSerial(String s) {
                info.setText("机型+序列号->:" + s);
            }
        });
//获取序列号
 bleBIZ.getSerialNo(new OnGetSerialListener() {
            @Override
            public void onGetSerial(String s) {
                info.setText("序列号->:" + s);
            }
        });
```

12.获取硬件版本编号

```Java
bleBIZ.getHardwareVersion(new OnGetHardwareVerListener() {
    @Override
    public void onGetHardwareVer(String s) {
        info.setText("硬件版本编号->:" + s);
    }
});
```

13.获取软件版本号

```
bleBIZ.getSoftwareVersion(new OnGetSoftwareVerListener() {
    @Override
    public void onGetSoftwareVer(String s) {
        info.setText("软件版本编号->:" + s);
    }
});
```

14.蓝牙软件版本号

```
bleBIZ.getBtVersion(new OnGetBtVerListener() {
    @Override
    public void onGetBtVer(String s) {
        info.setText("蓝牙软件版本编号->:" + s);
    }
});
```

15.获取本机联系电话

```
bleBIZ.getPhoneNo(new OnGetPhoneNoListener() {
    @Override
    public void onGetPhoneNumber(String s) {
        info.setText("电话->:" + s);
    }
});
```

16.获取本机版权信息

```
bleBIZ.getCopyRightInfo(new OnGetCopyrightInfoListener() {
    @Override
    public void onGetCopyright(String s) {
        info.setText("版权信息->:" + s);
    }
});
```

17.获取本机MAC

```
bleBIZ.getMAC(new OnGetMACListener() {
    @Override
    public void onGetMAC(String s) {
        info.setText("MAC->:" + s);
    }
});
```

#### **获取扫描数据**

- `广播获取`

  [^]: 您可以在程序中注册广播，并从广播中接收数据。（注意：android 8.0之后，静态广播的注册您将不会受到广播通知，所以建议您在代码中动态注册以保证广播数据的正常接收）

  

  ```java
  @Override
  protected void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);
  	IntentFilter filter = new IntentFilter();
    	filter.addAction(HycoConfig.KEY_ACTION_STRING_DATA_BLE);
      filter.addAction(HycoConfig.KEY_ACTION_OBJECT_DATA_BLE);
      filter.addAction(HycoConfig.KEY_ACTION_STATE_CHANGE_BLE);
    	filter.addAction(HycoConfig.HYCO_ACTION_OBJECT_POWER);
    	registerReceiver(receiver, filter);
  }
     BroadcastReceiver receiver = new BroadcastReceiver() {
          @Override
          public void onReceive(Context context, Intent intent) {
              String action = intent.getAction();
              switch (action) {
                  case HycoConfig.HYCO_ACTION_OBJECT_POWER:
  String power=intent.getStringExtra(HycoConfig.HYCO_VALUE_POWER);
                      Log.d(TAG, "====电量===="+power);
                      break;
                  case HycoConfig.KEY_ACTION_STRING_DATA_BLE:
                      Log.i(TAG, "onReceive: 扫描条码信息");
  String code = intent.getStringExtra(HycoConfig.KEY_VALUE_STRING);
  String format = intent.getStringExtra(HycoConfig.KEY_VALUE_FORMAT_STRING);
  String scantime = intent.getStringExtra(HycoConfig.KEY_VALUE_SCANTIME_STRING);
  String decodetime = intent.getStringExtra(HycoConfig.KEY_VALUE_DECODETIME_STRING);
                      barcode.setText("条码:" + code);
  
                      Log.e(TAG, "onReceive: code=" + code);
                       Log.e(TAG, "onReceive: 条码类型format=" + format);
                       Log.e(TAG, "onReceive: 识别时间scantime=" + scantime);
                       Log.e(TAG, "onReceive: 解码耗时decodetime=" + decodetime);
                      break;
                  case HycoConfig.KEY_ACTION_OBJECT_DATA_BLE:
                      Log.i(TAG, "onReceive: 扫描条码-SCANCODE");
  ScanData scanData = intent.getParcelableExtra(HycoConfig.KEY_VALUE_OBJECT);
                      info.setText("info->:" + scanData.toString());
                      break;
                  case HycoConfig.KEY_ACTION_STATE_CHANGE_BLE:
                      int state = intent.getIntExtra(HycoConfig.KEY_VALUE_STATE);
                      Log.i(TAG, "onReceive: 蓝牙状态");
                      /**
                      *枚举值如下：
                      * STATE_TURNING_ON = 11;
                      * STATE_ON = 12;
                      * STATE_OFF = 10;
                      * STATE_TURNING_OFF = 13;
                      */
  
                   
                      break;
              }
          }
      };
  ```

- `回调接口获取数据`

  [^]: 初始化`BleBIZ` 并设置回调方法，指环连接成功后扫描条码，数据将从回调方法中的onScanData(..)方法中返回。

  ```java
  private HycoBle ble = new HycoBle() {
          @Override
          public void onScanData(String barcode) {
              super.onScanData(barcode);
              ...
          }
  
          @Override
          public void onScanData(ScanData scanData) {
              super.onScanData(scanData);
              ...
          }
      };
  ```

#### **注意事项**

1. 权限请求包括蓝牙权限以及定位权限，如果弹出申请权限的兑换框，需要允许这两项权限。
2. 我司指环设备，目前w27支持屏幕扫描，如果指环扫描屏幕没有反应，还请打印配对码的条码，扫描纸质条码，依然可以完成配对的操作。
3. 如果不知道那一个指环连接了Android设备，可以点击屏幕上视图窗口，被连接的指环会亮灯并震动。
4. 对于开发者而言，上述的操作不需要赘写方法，sdk已经实现了上面的方法，只需要调用即可。
5. 最近SDK 包已经更改为Androidx下的包，开发者需要将您的项目包的support包替换为Androidx包。
6. 请务必打开手机通知权限，如果您关闭了通知，则有可能服务被杀死导致连接中断。

